/** 
 * @Version $Rev: 56 $
 * @Author M.Sekido
 * @Date  $Date: 2013-07-03 20:40:14 +0900 (Wed, 03 Jul 2013) $
 * $Id: cmplx.cpp 56 2013-07-03 11:40:14Z vlbi $ 
 */

#include "cmplx.hpp"
// #include "maxmin_v2.h"

void Cmaxmin_db::Max_min1(const FComplex* carr, long ndat1){
  ndat[0] = ndat1;
  
  const FComplex *pc = carr;
  cmax = carr[0];
  cmin = carr[0];

  for(int i=0; i<ndat1; i++){
    if(cmax < *pc){
      imax = i;
      cmax = *pc;
    }
    if(cmin > *pc){
      imin = i;
      cmin = *pc;
    }
    pc++;
  }
  
  double sum=0;
  int cnt=0;
  pc = carr;
  for(int i=0; i<ndat1; i++){
    if( i == imax || i == imin ) continue;
    sum += (pc++)->Amp();
    cnt++;
  }
  
  a_mean = sum/(double)cnt;
  snr = cmax.Amp()/a_mean;

}

void Cmaxmin_db::Max_min2(const FComplex* carr, long ndat1,
			  long ndat2){
  ndat[0]=ndat1;
  ndat[1]=ndat2;
  
  const FComplex *pc = carr;

  cmax = carr[0];
  cmin = carr[0];
  imax = 0;
  jmax = 0;
  for(int j=0; j<ndat2; j++){
    for(int i=0; i<ndat1; i++){
//       fprintf(stderr,"Max_min2: carr(%d,%d)=%f %f\n",
// 	      i,j,  pc->Real(), pc->Imag());
//       if(*pc == -nan) fprintf(stderr,"Max_min2: carr(%d,%d)=-nan\n",i,j);
      if( cmax < *pc){
	cmax = *pc;
	imax = i; jmax = j;
      }
      if( cmin > *pc){
	cmin = *pc;
	imin = i; jmin = j;
      }
      pc++;
    }
  }
  
  double sum=0;
  int cnt=0;
  pc = carr;
  for(int j=0; j<ndat2; j++){
    for(int i=0; i<ndat1; i++){
      if( i == imax || i == imin || j == jmax || j == jmin) continue;
      sum += (pc++)->Amp();
      cnt++;
    }
  }
  
  a_mean = sum/cnt;
  snr = cmax.Amp()/a_mean;
  


};


